// ---------------------------------------------------------------- -*- C++ -*-
// File: ilconcert/ilobasic.h
// ----------------------------------------------------------------------------
//  Copyright (C) 1999-2006 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// ----------------------------------------------------------------------------

#ifndef __CONCERT_IloBasicH
#define __CONCERT_IloBasicH

#ifndef __CONCERT_ilosysH
#include <ilconcert/ilosys.h>
#endif

//#ifdef ILOCONCERT20
#ifndef __CONCERT_iloalgH
#include <ilconcert/iloalg.h>
#endif
//#else
//#ifndef __CONCERT_ilotypesH
//#include <ilconcert/ilotypes.h>
//#endif
//#endif

#define IloNumToNumStepFunctionI    IloSegmentedFunctionI
#define IloNumToNumSegmentFunctionI IloSegmentedFunctionI

//-----------------------------------------------------------
// Macros
//-----------------------------------------------------------

#if defined(ILO_HP_aCC)
#define ILOCOPYCTOR(Hname) Hname(const Hname& h):_impl(h._impl){}
#else
#define ILOCOPYCTOR(Hname)
#endif

#define ILOHANDLEMINI(Hname, Iname)\
  typedef Iname ImplClass; \
public:\
 Hname():_impl(0){}\
 Hname(Iname* impl):_impl(impl){}\
 ILOCOPYCTOR(Hname)\
 Iname* getImpl() const {return _impl;}\
 void operator=(const Hname& h){_impl = h._impl;}\
protected:\
 Iname* _impl

#define ILOHANDLEMININOIMPL(Hname, Iname, RHname)\
  typedef Iname ImplClass; \
public:\
 Hname():RHname(){}\
 Hname(Iname* impl):RHname(impl){}\
 Iname* getImpl() const {return (Iname*)RHname::getImpl();}


#endif
