// ---------------------------------------------------------------- -*- C++ -*-
// File: ilconcert/iloparam.h
// ----------------------------------------------------------------------------
//  Copyright (C) 1999-2006 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// ----------------------------------------------------------------------------

#ifndef __CONCERT_IloParamH
#define __CONCERT_IloParamH

#ifndef __CONCERT_IloParamIH
#include <ilconcert/iloparami.h>
#endif

class IloParameter {
	ILOHANDLEMINI(IloParameter,IloParameterI);
public:
	inline void display(ILOSTD(ostream)& out) const {
		getImpl()->display(out);
	}
	inline void end() const {
		delete getImpl();
		((IloParameter*)this)->_impl = 0;
	}
	ILOEXTENSIONH(IloParameterI)
};

#endif
